game = {}

function game.load()
	blip.load()
	snake = {
		x = 400,
		y = 240,
		dir = "up", --left right up down
		speed = 0.1
	}
	snakebits = {}
	snakebits[#snakebits + 1] = {x = snake.x, y = snake.y, fuckoff = false}
	bg = love.graphics.newImage("assets/img/bg.png")
	--GAME STUFF
	snakel = 5
	tick = 0
	lost = false
	lostwait = 1
	ltick = 0
	score = 0
end

function game.reset()
	snake.x = 400
	snake.y = 240
	snake.dir = "up"
	lost = false
	score = 0
	snakel = 5
	for i=#snakebits, 1, -1 do
		table.remove(snakebits, i)
	end
	for i=#blips, 1, -1 do
		table.remove(blips, i)
	end
end

function game.update(dt)
	--SNAKE MOTION
	if not lost then
		tick = tick + dt
		if tick > snake.speed then
			if snake.dir == "left" then
				snake.x = snake.x - 16
			elseif snake.dir == "right" then
				snake.x = snake.x + 16
			elseif snake.dir == "up" then
				snake.y = snake.y - 16
			elseif snake.dir == "down" then
				snake.y = snake.y + 16
			end
			snakebits[#snakebits + 1] = {x = snake.x, y = snake.y, fuckoff = false}
			tick = 0
		end
		--Trail
		if #snakebits > snakel then
			snakebits[1].fuckoff = true
		end
		for i=1, #snakebits do
			if snakebits[i].fuckoff then
				table.remove(snakebits, i)
				break
			end
		end
		blip.update(dt)
		--BLIP / SNAKE COL
		for s=1, #blips do
			if snake.x == blips[s].x and snake.y == blips[s].y then
				snakel = snakel + 1
				score = score + 1
				blips[s].fuckoff = true
				break
			end
		end
		for d=1, #blips do
			if blips[d].fuckoff then
				table.remove(blips, d)
				break
			end
		end
		--SNAKE / WALLS COL
		if snake.x > grid.w*16 then
			snake.x = 0
		elseif snake.x < 0 then
			snake.x = grid.w*16
		elseif snake.y > grid.h*16 then
			snake.y = 0
		elseif snake.y < 0 then
			snake.y = grid.h * 16
		end
		--SNAKE / SNAKE COL
		if snake.dir == "right" then
			for i=1, #snakebits do
				if snake.x + 16 == snakebits[i].x and snake.y == snakebits[i].y then
					lost = true
				end
			end
		elseif snake.dir == "left" then
			for i=1, #snakebits do
				if snake.x - 16 == snakebits[i].x and snake.y == snakebits[i].y then
					lost = true
				end
			end
		elseif snake.dir == "up" then
			for i=1, #snakebits do
				if snake.y - 16 == snakebits[i].y and snake.x == snakebits[i].x then
					lost = true
				end
			end
		elseif snake.dir == "down" then
			for i=1, #snakebits do
				if snake.y + 16 == snakebits[i].y and snake.x == snakebits[i].x then
					lost = true
				end
			end
		end
	else
		--Lost
		ltick = ltick + dt
		if ltick > lostwait then
			game.reset()
			ltick = 0
		end
	end
end

function game.draw()
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(bg)
	love.graphics.rectangle("fill", snake.x, snake.y, 16, 16)
	--trail
	for i=1, #snakebits do
		love.graphics.rectangle("fill", snakebits[i].x, snakebits[i].y, 16, 16)
	end
	--Blips
	love.graphics.setColor(255, 255, 255, 255)
	for b=1, #blips do
		love.graphics.rectangle("fill", blips[b].x+4, blips[b].y+4, 8, 8)
	end
	--HUD
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.print("Score: "..score, 10, 10)
	love.graphics.print("FPS: "..love.timer.getFPS(), 10, 24)
end

function game.keypressed(key)
	if key == "w" or key == "up" then
		if snake.dir == "left" or snake.dir == "right" then
			snake.dir = "up"
		end
	elseif key == "s" or key == "down" then
		if snake.dir == "left" or snake.dir == "right" then
			snake.dir = "down"
		end
	elseif key == "d" or key == "right" then
		if snake.dir == "up" or snake.dir == "down" then
			snake.dir = "right"
		end
	elseif key == "a" or key == "left" then
		if snake.dir == "up" or snake.dir == "down" then
			snake.dir = "left"
		end
	end
end

--Blip spawner
blip = {
	rate = 2--Spawn rate
}

function blip.load()
	blips = {}
	btick = 0
	
end

function blip.update(dt)
	btick = btick + dt
	if btick > blip.rate then
		local rx = math.random(0, grid.w)
		local ry = math.random(0, grid.h)
		blip.add(rx*16, ry*16)
		btick = 0
	end
end

function blip.add(dx, dy)
	blips[#blips + 1] = {
		x = dx,
		y = dy,
		fuckoff = false
	}
end














